Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 225353)
+++ channels/chan_sip.c	(working copy)
@@ -4985,6 +4985,12 @@
 	struct sip_peer *p = NULL;
 	struct sip_peer tmp_peer;
 
+	if (realtime || devstate_only) {
+		p = realtime_peer(peer, sin, devstate_only);
+		if (p)
+			return p;
+	}
+	
 	if (peer) {
 		ast_copy_string(tmp_peer.name, peer, sizeof(tmp_peer.name));
 		p = ao2_t_callback_data(peers, OBJ_POINTER, find_by_name, &tmp_peer, &which_objects, "ao2_find in peers table");
@@ -5003,10 +5009,6 @@
 		}
 	}
 
-	if (!p && (realtime || devstate_only)) {
-		p = realtime_peer(peer, sin, devstate_only);
-	}
-
 	return p;
 }
 
